Program scan_latlng;
{$mode objfpc}{$h+}
uses sqldb, pqconnection, cwstring,
     sysutils, unix, xmlfile;

Var
  C : TSQLConnection;
  T : TSQLTransaction;
  Q : TSQLQuery;

Function IntToStr (I : Longint) : String;
Var S : String;
begin
 Str (I,S);
 IntToStr:=S;
end;

Function FloatToStr (R:double) : String;
Var S : String;
begin
 Str(R,S);
 FloatToStr:=S;
end;

var
 sid,cnt:longint;
 obl,man,place,addr,callstr:AnsiString;
 GCStatus:string; lat,lng:double;
 xGLL:TXMLFile; {Google coordinates response}

function Sp2Plus(str:AnsiString):AnsiString;
var i:integer; s:WideString;
begin
 s:=str;
 for i:=1 to length(s) do 
  if (s[i]=' ') or (s[i]='"')
   then s[i]:='+';
 Sp2Plus:=s;
end;

procedure GetLatLng;
 var urlOK:boolean; uq,u_part,k_part,fadr:AnsiString; i:integer;
 procedure GetPart(patt:string; var part:AnsiString);
  procedure Clear(pt:String);
   begin i:=Pos(pt,part); if i>0 then delete(part,i,length(pt)) end;
  begin
    part:=addr; 
    i:=Pos(patt,part); 
    if i>0 then begin
     delete(part,1,i-1);
     Clear('No'); Clear('Nо'); 
     Clear('№'); // Clear('№ ');
     i:=1;
     while (i<=length(part)) and (not (part[i] in ['0'..'9'])) do inc(i);
     while (i<=length(part)) and (part[i] in ['0'..'9']) do inc(i);
     delete(part,i,length(part));
    end
    else part:='';
  end;
 begin
   urlOK:=false;
   callstr:='wget -O LatLong.xml https://maps.google.com/maps/api/geocode/xml?address=';
   if (Pos('село ',place)=1) then begin
    callstr:=callstr+Sp2Plus(place)+',+община+'+Sp2Plus(man)+',+BG';
    urlOK:=true;
   end;
   if (Pos('град ',place)=1) then begin
    if Pos('бул.',addr)>0
     then GetPart('бул.',u_part)
     else GetPart('ул.',u_part);
    if Pos('жк.',addr)>0
     then GetPart('жк.',k_part)
     else GetPart('кв.',k_part); 
    writeln('UL=',u_part,' KV=',k_part);
    if k_part<>'' then begin
     fadr:=k_part;
     if u_part<>'' then fadr:=fadr+', '+u_part;
    end else fadr:=u_part;
    callstr:=callstr+Sp2Plus(fadr)+',+'+Sp2Plus(place)+',+BG';
    urlOK:=length(fadr)>0;
   end;
   writeln(callstr);
   if urlOK then begin
    fpSystem(callstr+' 2>/dev/null');
    xGLL := TXMLFile.Create('LatLong.xml','GeocodeResponse',true {read only mode} );
    GCStatus:=xGLL.ReadString('status','','error');
    lat:=0; lng:=0;
    writeln('GeocodeResponse status=',GCStatus);
    if GCStatus='OK' then begin
     lat:=xGLL.ReadFloat('result.geometry.location','lat',0);
     lng:=xGLL.ReadFloat('result.geometry.location','lng',0);
//     writeln('UPDATE sections SET lat=',lat:10:7,', lng=',lng:10:7,' WHERE id=',sid,';');
     uq:='UPDATE sections SET lat='+FloatToStr(lat)+', lng='+FloatToStr(lng)+' WHERE id='+IntToStr(sid)+';';
//     writeln('psql test1 -c "',uq,'"');
     uq:='psql test1 -c "'+uq+'"';
     fpSystem(uq);
    end;
    xGLL.Destroy;
   end;
 end;

var mname:AnsiString;

procedure Loop;
 begin
    // Create a query to return data
    Q:=TSQLQuery.Create(C);
    // Point to database and transaction.
    Q.Database:=C;
    Q.Transaction:=T;
    // Set the SQL select statement
    Q.SQL.Text:=
     'select sections.id as sid, obl_name, man_name, place, addr '+
     'from regions, sections where '+ 
     'reg_id=regions.id and lat=0 and man_name='''+mname+'''';
    Q.Open; cnt:=0;
    While not Q.EOF do begin
      sid:=Q.FieldByName('sid').AsInteger;
      obl:=Q.FieldByName('obl_name').AsWideString;
      man:=Q.FieldByName('man_name').AsWideString;
      place:=Q.FieldByName('place').AsWideString;
      addr:=Q.FieldByName('addr').AsWideString;
      cnt:=cnt+1;
//      if cnt<3 then begin
       Writeln('sid=',sid,', област ',obl,', община ',man,', ',place,', адрес: ',addr);
       GetLatLng;
//      end;
      Q.Next
    end;
    Q.Close;  
 end;

begin
  mname:='Мъглиж';
  if ParamCount>0 then mname:=ParamStr(1);
  C:=TPQConnection.Create(Nil);
  try
    C.UserName:='skelet';
    C.DatabaseName:='test1';
    T:=TSQLTransaction.Create(C);
    T.Database:=C;
    C.Connected:=True;
    Loop;
  finally
    C.Free;
  end;
end.  


