Program scan_ll_xy;
{
  Изчислява приближени координати за всички секции:
  - при точен адрес взема случайна точка от ограничаващия правоъгълник
  - за села взема случайна точка от огр. прав. на селото
  - при неточен адрес взема сл. точка от нас. място
}
{$mode objfpc}{$h+}
uses sqldb, pqconnection, cwstring,
     sysutils, unix, xmlfile;

Var
  C : TSQLConnection;
  T : TSQLTransaction;
  Q : TSQLQuery;

Function IntToStr (I : Longint) : String;
Var S : String;
begin
 Str (I,S);
 IntToStr:=S;
end;

Function FloatToStr (R:double) : String;
Var S : String;
begin
 Str(R,S);
 FloatToStr:=S;
end;

var
 sid,cnt:longint;
 obl,man,place,addr,callstr:AnsiString;
 GCStatus:string; 
 lat,lng:double;
 xGLL:TXMLFile; {Google coordinates response}

function Sp2Plus(str:AnsiString):AnsiString;
var i:integer; s:WideString;
begin
 s:=str;
 for i:=1 to length(s) do 
  if (s[i]=' ') or (s[i]='"')
   then s[i]:='+';
 Sp2Plus:=s;
end;

procedure GetLatLng;
 const 
  wgetaddr:AnsiString='wget -O LatLong.xml "https://maps.google.com/maps/api/geocode/xml?address=';
  keystr:AnsiString='&key=AIzaSyAZwNp3W3lOnRfkyazZHnTaxiX5xwOhpmI"';
 var urlOK:boolean; 
     uq,u_part,k_part,fadr,urlMode:AnsiString; 
     i:integer;
     latr,lngr,area,x0,x1,y0,y1:double;
 procedure GetPart(patt:string; var part:AnsiString);
  procedure Clear(pt:String);
   begin i:=Pos(pt,part); if i>0 then delete(part,i,length(pt)) end;
  begin
    part:=addr; 
    i:=Pos(patt,part); 
    if i>0 then begin
     delete(part,1,i-1);
     Clear('No'); Clear('Nо'); 
     Clear('№'); // Clear('№ ');
     i:=1;
     while (i<=length(part)) and (not (part[i] in ['0'..'9'])) do inc(i);
     while (i<=length(part)) and (part[i] in ['0'..'9']) do inc(i);
     delete(part,i,length(part));
    end
    else part:='';
  end;
 begin
   urlOK:=false;
//   callstr:='wget -O LatLong.xml https://maps.google.com/maps/api/geocode/xml?address=';
   urlMode:='unknown';
   if (Pos('село ',place)=1) then begin
    callstr:=wgetaddr+Sp2Plus(place)+',+община+'+Sp2Plus(man)+',+BG';
    urlOK:=true;
   urlMode:='village';
   end;
   if (Pos('град ',place)=1) then begin
    if Pos('бул.',addr)>0
     then GetPart('бул.',u_part)
     else GetPart('ул.',u_part);
    if Pos('жк.',addr)>0
     then GetPart('жк.',k_part)
     else GetPart('кв.',k_part); 
    writeln('UL=',u_part,' KV=',k_part);
    if k_part<>'' then begin
     fadr:=k_part;
     if u_part<>'' then fadr:=fadr+', '+u_part;
    end else fadr:=u_part;
    callstr:=wgetaddr+Sp2Plus(fadr)+',+'+Sp2Plus(place)+',+BG';
    urlOK:=length(fadr)>0;
    urlMode:='address';
   end;
   if not urlOK then begin
    urlMode:='no_addr';
    callstr:=wgetaddr+Sp2Plus(place)+',+община+'+Sp2Plus(man)+',+BG';
   end;
 
   fpSystem(callstr+keystr+' 2>/dev/null');
   xGLL := TXMLFile.Create('LatLong.xml','GeocodeResponse',true {read only mode} );
   GCStatus:=xGLL.ReadString('status','','error');
   if GCStatus<>'OK' then begin
    xGLL.Destroy;
    urlMode:='average';
    callstr:=wgetaddr+Sp2Plus(place)+',+община+'+Sp2Plus(man)+',+BG';
    fpSystem(callstr+keystr+' 2>/dev/null');
    xGLL := TXMLFile.Create('LatLong.xml','GeocodeResponse',true {read only mode} );
    GCStatus:=xGLL.ReadString('status','','error');
   end;

   writeln(urlMode,'=> ',callstr);
//   writeln('GeocodeResponse status=',GCStatus);
   if GCStatus='OK' then begin
     lat:=xGLL.ReadFloat('result.geometry.location','lat',0);
     lng:=xGLL.ReadFloat('result.geometry.location','lng',0);
     x0:=xGLL.ReadFloat('result.geometry.viewport.southwest','lng',0);
     x1:=xGLL.ReadFloat('result.geometry.viewport.northeast','lng',0);
     y0:=xGLL.ReadFloat('result.geometry.viewport.southwest','lat',0);
     y1:=xGLL.ReadFloat('result.geometry.viewport.northeast','lat',0);
     area:=(x1-x0)*(y1-y0);
     latr:=y0+Random*(y1-y0);
     lngr:=x0+Random*(x1-x0);
     writeln(urlMode,'=> lat=',lat:10:7,', lng=',lng:10:7,' area=',area:10:7,' latr=',latr:10:7,', lngr=',lngr:10:7);
     uq:=
      'UPDATE sections SET lat='+FloatToStr(lat)+', lng='+FloatToStr(lng)+
      ', latr='+FloatToStr(latr)+', lngr='+FloatToStr(lngr)+
      ', area='+FloatToStr(area)+', g_mode='''+urlMode+''''+
      ' WHERE id='+IntToStr(sid)+';';
//     writeln(uq);
     uq:='psql test1 -c "'+uq+'"';
     fpSystem(uq);
{
//     writeln('UPDATE sections SET lat=',lat:10:7,', lng=',lng:10:7,' WHERE id=',sid,';');
     uq:='UPDATE sections SET lat='+FloatToStr(lat)+', lng='+FloatToStr(lng)+' WHERE id='+IntToStr(sid)+';';
//     writeln('psql test1 -c "',uq,'"');
     uq:='psql test1 -c "'+uq+'"';
     fpSystem(uq);
}
   end;
   xGLL.Destroy;
 end;

var mname:AnsiString;

procedure Loop;
 begin
    // Create a query to return data
    Q:=TSQLQuery.Create(C);
    // Point to database and transaction.
    Q.Database:=C;
    Q.Transaction:=T;
    // Set the SQL select statement
    Q.SQL.Text:=
     'select sections.id as sid, obl_name, man_name, place, addr '+
     'from regions, sections where '+ 
     'reg_id=regions.id'+
//     ' and man_name='''+mname+''''+
     ' and obl_name=''Стара Загора'''+
     ' and ((latr is null) or (latr=0))';
    Q.Open; cnt:=0;
    While not Q.EOF do begin
      sid:=Q.FieldByName('sid').AsInteger;
      obl:=Q.FieldByName('obl_name').AsWideString;
      man:=Q.FieldByName('man_name').AsWideString;
      place:=Q.FieldByName('place').AsWideString;
      addr:=Q.FieldByName('addr').AsWideString;
      cnt:=cnt+1;
//      if cnt<3 then begin
       Writeln('sid=',sid,', област ',obl,', община ',man,', ',place,', адрес: ',addr);
       GetLatLng;
//      end;
      Q.Next
    end;
    Q.Close;  
 end;

begin
  mname:='Мъглиж';
  Randomize;
  if ParamCount>0 then mname:=ParamStr(1);
  C:=TPQConnection.Create(Nil);
  try
    C.UserName:='skelet';
    C.DatabaseName:='test1';
    T:=TSQLTransaction.Create(C);
    T.Database:=C;
    C.Connected:=True;
    Loop;
  finally
    C.Free;
  end;
end.  


