Program init_sections;
{$mode objfpc}{$h+}
uses sqldb, pqconnection, cwstring,
     sysutils, unix;
{
 Read from file sections.txt
 Write to SQL insert stream for table sections: 

create table sections 
 (id serial primary key, 
  reg_id integer refereces regions,  
  sec_id integer, 
  place text, place_code integer, 
  addr text,
  elect2015 integer,
  lat float,
  lng float);

}
Var 
  S : AnsiString;
  P : PChar;
  mir_name,ob_name,r_name,sec_str,place,addr,callstr:AnsiString;
  mir,ob_id,r_id,reg_id,sec_id,place_code,electors:longint;
  valc,cnt:word;
//  xGLL:TXMLFile; {Google coordinates response}

Var
  C : TSQLConnection;
  T : TSQLTransaction;
  Q : TSQLQuery;

Function IntToStr (I : Longint) : String;
Var S : String;
begin
 Str (I,S);
 IntToStr:=S;
end;

procedure GetInt(var i:longint);
begin
  S[Pos(',',S)]:=' ';
  ReadStr(S,i);
  Delete(S,1,Pos(' ',S));
end;

procedure GetStr(var str:AnsiString);
begin
  P:=Pchar(S);
  str:=AnsiExtractQuotedStr(P,'"');
  S:=AnsiString(P);
  Delete(S,1,1);
end;

function UpLowCase(str:AnsiString):AnsiString;
var w,s,r:WideString; f:boolean;
begin
 s:=str; r:=''; f:=true;
 while length(s)>0 do begin
  w:=copy(s,1,1);
  delete(s,1,1);
  if f
   then r:=r+WideUpperCase(w)
   else r:=r+WideLowerCase(w);
  f:=w=' ';
 end;
 UpLowCase:=r;
end;

function Sp2Plus(str:AnsiString):AnsiString;
var i:integer; s:WideString;
begin
 s:=str;
 for i:=1 to length(s) do if s[i]=' ' then s[i]:='+';
 Sp2Plus:=s;
end;

procedure FormatPlace;
var dotp:word; ptype:string;
begin
 dotp:=Pos('.',place); 
 ptype:='WRONG ';
 if Pos('С.',place)=1 then ptype:='село ';
 if Pos('ГР.',place)=1 then ptype:='град ';
 place:=ptype+UpLowCase(copy(place,dotp+1,length(place)-dotp));
end;

function GetRegId(obl,man,sub:longint):longint;
 begin
    // Create a query to return data
    Q:=TSQLQuery.Create(C);
    // Point to database and transaction.
    Q.Database:=C;
    Q.Transaction:=T;
    // Set the SQL select statement
    Q.SQL.Text:='SELECT id FROM regions WHERE obl_id='+
                IntToStr(obl)+' and man_id='+IntToStr(man)+' and sub_id='+IntToStr(sub);
    // And now use the standard TDataset methods.
    Q.Open;
    GetRegId:=-1;
    if Q.RecordCount=1 then GetRegId:=Q.FieldByName('id').AsInteger;
    Q.Close;  
 end;

procedure Loop;
begin
 writeln('begin transaction;');
 while not eof(input) do begin
  readln(S); S:=S+',';
//  writeln(S);
  GetInt(mir); GetStr(mir_name); //mir_name:=AnsiQuotedStr(UpLowCase(mir_name),'''');
  GetInt(ob_id); GetStr(ob_name); //ob_name:=AnsiQuotedStr(UpLowCase(ob_name),'''');
  GetInt(r_id); GetStr(r_name); //r_name:=AnsiQuotedStr(UpLowCase(r_name),'''');
  reg_id:=GetRegId(mir,ob_id,r_id);
  GetStr(sec_str); val(sec_str,sec_id,valc);
  GetInt(place_code); 
  GetStr(place); FormatPlace;
  GetStr(addr);
  GetInt(electors);
  if reg_id>=0 
   then writeln('insert into sections values (DEFAULT,',
    reg_id,',',sec_id,',',AnsiQuotedStr(place,''''),',',place_code,',',
    AnsiQuotedStr(addr,''''),',',electors,
    ',0.0,0.0);')
   else writeln(stderr,'ERROR: Region id is wrong!'); 
 end;
 writeln('end transaction;');
end;

begin
  C:=TPQConnection.Create(Nil);
  try
    C.UserName:='skelet';
    C.DatabaseName:='test1';
    T:=TSQLTransaction.Create(C);
    T.Database:=C;
    C.Connected:=True;
    Loop;
  finally
    C.Free;
  end;
end.  

